// http://www.khronos.org/files/opengl-quick-reference-card.pdf

uniform sampler2D colorMap;
uniform sampler2D glossMap;
uniform sampler2D normalMap;

varying vec3 vLight;
varying vec3 vView;
varying vec3 vNormal;

varying mat3 TBN_mat;


void main()
{
	vec3 light=normalize(vLight);
	vec3 view=normalize(vView);
	vec3 tsNormal=texture2D(normalMap, gl_TexCoord[0].xy).xyz - 0.5;

	vec3 normal=tsNormal*vec3(1.0,1.0,1.0);
	normal=normalize(TBN_mat*normal);

	float specularLit=0.0;
	float diffuseLit=max(0.0,dot(light,normal));

	vec3 lightReflect = reflect(light,normal);
			
	vec4 gloss=texture2D(glossMap, gl_TexCoord[0].xy);
	specularLit=pow(max(0.0,-dot(lightReflect,view)),16.0) * gloss.r;

	float lit=diffuseLit+specularLit;

	gl_FragData[0] = lit*texture2D(colorMap, gl_TexCoord[0].xy);
}
