// http://www.khronos.org/files/opengl-quick-reference-card.pdf

uniform vec3 inLightPos;

attribute vec4 inVertPos;
attribute vec4 inTexCoord;

attribute vec3 inVertNormal;
attribute vec3 inTangent;
attribute vec3 inBinormal;

varying vec3 vLight;
varying vec3 vView;
varying vec3 vNormal;

varying mat3 TBN_mat;


void main()
{
	gl_TexCoord[0]=inTexCoord;

// view space
	vec4 vPos=gl_ModelViewMatrix * inVertPos;
	TBN_mat[0]=gl_NormalMatrix * inTangent;
	TBN_mat[1]=gl_NormalMatrix * inBinormal;
	TBN_mat[2]=gl_NormalMatrix * inVertNormal;

	vNormal = gl_NormalMatrix * inVertNormal;
	vView = -vPos.xyz;
	vLight = inLightPos - vPos.xyz;

// projection space
	gl_Position = gl_ProjectionMatrix * vPos;
}
